﻿/// <reference path="viewModel.js" />

(function (lightSwitchApplication) {

    var $element = document.createElement("div");

    lightSwitchApplication.Schedule.prototype._$contentItems = {
        Tabs: {
            _$class: msls.ContentItem,
            _$name: "Tabs",
            _$parentName: "RootContentItem",
            screen: lightSwitchApplication.Schedule
        },
        Group: {
            _$class: msls.ContentItem,
            _$name: "Group",
            _$parentName: "Tabs",
            screen: lightSwitchApplication.Schedule,
            data: lightSwitchApplication.Schedule,
            value: lightSwitchApplication.Schedule
        },
        ScheduleEvents: {
            _$class: msls.ContentItem,
            _$name: "ScheduleEvents",
            _$parentName: "Group",
            screen: lightSwitchApplication.Schedule,
            data: lightSwitchApplication.Schedule,
            value: {
                _$class: msls.VisualCollection,
                screen: lightSwitchApplication.Schedule,
                _$entry: {
                    elementType: lightSwitchApplication.ScheduleEvent
                }
            }
        },
        ScheduleEventsTemplate: {
            _$class: msls.ContentItem,
            _$name: "ScheduleEventsTemplate",
            _$parentName: "ScheduleEvents",
            screen: lightSwitchApplication.Schedule,
            data: lightSwitchApplication.ScheduleEvent,
            value: lightSwitchApplication.ScheduleEvent
        },
        Id: {
            _$class: msls.ContentItem,
            _$name: "Id",
            _$parentName: "ScheduleEventsTemplate",
            screen: lightSwitchApplication.Schedule,
            data: lightSwitchApplication.ScheduleEvent,
            value: Number
        },
        StartTime: {
            _$class: msls.ContentItem,
            _$name: "StartTime",
            _$parentName: "ScheduleEventsTemplate",
            screen: lightSwitchApplication.Schedule,
            data: lightSwitchApplication.ScheduleEvent,
            value: Date
        },
        EndTime: {
            _$class: msls.ContentItem,
            _$name: "EndTime",
            _$parentName: "ScheduleEventsTemplate",
            screen: lightSwitchApplication.Schedule,
            data: lightSwitchApplication.ScheduleEvent,
            value: Date
        },
        AllDay: {
            _$class: msls.ContentItem,
            _$name: "AllDay",
            _$parentName: "ScheduleEventsTemplate",
            screen: lightSwitchApplication.Schedule,
            data: lightSwitchApplication.ScheduleEvent,
            value: Boolean
        },
        Recurrence: {
            _$class: msls.ContentItem,
            _$name: "Recurrence",
            _$parentName: "ScheduleEventsTemplate",
            screen: lightSwitchApplication.Schedule,
            data: lightSwitchApplication.ScheduleEvent,
            value: Boolean
        },
        RecurrenceRule: {
            _$class: msls.ContentItem,
            _$name: "RecurrenceRule",
            _$parentName: "ScheduleEventsTemplate",
            screen: lightSwitchApplication.Schedule,
            data: lightSwitchApplication.ScheduleEvent,
            value: String
        },
        StartTimeZone: {
            _$class: msls.ContentItem,
            _$name: "StartTimeZone",
            _$parentName: "ScheduleEventsTemplate",
            screen: lightSwitchApplication.Schedule,
            data: lightSwitchApplication.ScheduleEvent,
            value: String
        },
        EndTimeZone: {
            _$class: msls.ContentItem,
            _$name: "EndTimeZone",
            _$parentName: "ScheduleEventsTemplate",
            screen: lightSwitchApplication.Schedule,
            data: lightSwitchApplication.ScheduleEvent,
            value: String
        },
        Categorize: {
            _$class: msls.ContentItem,
            _$name: "Categorize",
            _$parentName: "ScheduleEventsTemplate",
            screen: lightSwitchApplication.Schedule,
            data: lightSwitchApplication.ScheduleEvent,
            value: String
        },
        StaffId: {
            _$class: msls.ContentItem,
            _$name: "StaffId",
            _$parentName: "ScheduleEventsTemplate",
            screen: lightSwitchApplication.Schedule,
            data: lightSwitchApplication.ScheduleEvent,
            value: Number
        },
        Popups: {
            _$class: msls.ContentItem,
            _$name: "Popups",
            _$parentName: "RootContentItem",
            screen: lightSwitchApplication.Schedule
        }
    };

    msls._addEntryPoints(lightSwitchApplication.Schedule, {
        /// <field>
        /// Called when a new Schedule screen is created.
        /// <br/>created(msls.application.Schedule screen)
        /// </field>
        created: [lightSwitchApplication.Schedule],
        /// <field>
        /// Called before changes on an active Schedule screen are applied.
        /// <br/>beforeApplyChanges(msls.application.Schedule screen)
        /// </field>
        beforeApplyChanges: [lightSwitchApplication.Schedule],
        /// <field>
        /// Called after the Group content item has been rendered.
        /// <br/>postRender(HTMLElement element, msls.ContentItem contentItem)
        /// </field>
        Group_postRender: [$element, function () { return new lightSwitchApplication.Schedule().findContentItem("Group"); }],
        /// <field>
        /// Called to render the ScheduleEvents content item.
        /// <br/>render(HTMLElement element, msls.ContentItem contentItem)
        /// </field>
        ScheduleEvents_render: [$element, function () { return new lightSwitchApplication.Schedule().findContentItem("ScheduleEvents"); }],
        /// <field>
        /// Called after the ScheduleEventsTemplate content item has been rendered.
        /// <br/>postRender(HTMLElement element, msls.ContentItem contentItem)
        /// </field>
        ScheduleEventsTemplate_postRender: [$element, function () { return new lightSwitchApplication.Schedule().findContentItem("ScheduleEventsTemplate"); }],
        /// <field>
        /// Called after the Id content item has been rendered.
        /// <br/>postRender(HTMLElement element, msls.ContentItem contentItem)
        /// </field>
        Id_postRender: [$element, function () { return new lightSwitchApplication.Schedule().findContentItem("Id"); }],
        /// <field>
        /// Called after the StartTime content item has been rendered.
        /// <br/>postRender(HTMLElement element, msls.ContentItem contentItem)
        /// </field>
        StartTime_postRender: [$element, function () { return new lightSwitchApplication.Schedule().findContentItem("StartTime"); }],
        /// <field>
        /// Called after the EndTime content item has been rendered.
        /// <br/>postRender(HTMLElement element, msls.ContentItem contentItem)
        /// </field>
        EndTime_postRender: [$element, function () { return new lightSwitchApplication.Schedule().findContentItem("EndTime"); }],
        /// <field>
        /// Called after the AllDay content item has been rendered.
        /// <br/>postRender(HTMLElement element, msls.ContentItem contentItem)
        /// </field>
        AllDay_postRender: [$element, function () { return new lightSwitchApplication.Schedule().findContentItem("AllDay"); }],
        /// <field>
        /// Called after the Recurrence content item has been rendered.
        /// <br/>postRender(HTMLElement element, msls.ContentItem contentItem)
        /// </field>
        Recurrence_postRender: [$element, function () { return new lightSwitchApplication.Schedule().findContentItem("Recurrence"); }],
        /// <field>
        /// Called after the RecurrenceRule content item has been rendered.
        /// <br/>postRender(HTMLElement element, msls.ContentItem contentItem)
        /// </field>
        RecurrenceRule_postRender: [$element, function () { return new lightSwitchApplication.Schedule().findContentItem("RecurrenceRule"); }],
        /// <field>
        /// Called after the StartTimeZone content item has been rendered.
        /// <br/>postRender(HTMLElement element, msls.ContentItem contentItem)
        /// </field>
        StartTimeZone_postRender: [$element, function () { return new lightSwitchApplication.Schedule().findContentItem("StartTimeZone"); }],
        /// <field>
        /// Called after the EndTimeZone content item has been rendered.
        /// <br/>postRender(HTMLElement element, msls.ContentItem contentItem)
        /// </field>
        EndTimeZone_postRender: [$element, function () { return new lightSwitchApplication.Schedule().findContentItem("EndTimeZone"); }],
        /// <field>
        /// Called after the Categorize content item has been rendered.
        /// <br/>postRender(HTMLElement element, msls.ContentItem contentItem)
        /// </field>
        Categorize_postRender: [$element, function () { return new lightSwitchApplication.Schedule().findContentItem("Categorize"); }],
        /// <field>
        /// Called after the StaffId content item has been rendered.
        /// <br/>postRender(HTMLElement element, msls.ContentItem contentItem)
        /// </field>
        StaffId_postRender: [$element, function () { return new lightSwitchApplication.Schedule().findContentItem("StaffId"); }]
    });

}(msls.application));